register = ["REGISTER sip:#server_ip# SIP/2.0\r\n",
            "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
            "Max-Forwards: 70\r\n",
            "Contact: <sip:#username#@#client_ip#:#client_port#;transport=UDP>\r\n",
            "To: \"#username#\"<sip:#username#@#server_ip#;transport=UDP>\r\n",
            "From: \"#username#\"<sip:#username#@#server_ip#>;tag=#tag#\r\n",
            "Call-ID: #call_id_counter#@#server_ip#:5060\r\n",
            "CSeq: #cseq_id# REGISTER\r\n",
            "Expires: #time_ex#\r\n",
            "Allow: #allow#\r\n",
            "User-Agent: VoiPy #user_version#\r\n",
            "Content-Length: 0\r\n\r\n"]
register_auth = ["REGISTER sip:#server_ip# SIP/2.0\r\n",
                 "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                 "Max-Forwards: 70\r\n",
                 "Contact: <sip:#username#@#client_ip#:#client_port#;transport=UDP>\r\n",
                 "To: \"#username#\"<sip:#username#@#server_ip#;transport=UDP>\r\n",
                 "From: \"#username#\"<sip:#username#@#server_ip#>;tag=#tag#\r\n",
                 "Call-ID: #call_id_counter#@#server_ip#:5060\r\n",
                 "CSeq: #cseq_id# REGISTER\r\n",
                 "Expires: #time_ex#\r\n",
                 "Allow: #allow#\r\n",
                 "User-Agent: VoiPy #user_version#\r\n",
                 "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
                 "uri=\"sip:#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
                 "Content-Length: 0\r\n\r\n"]
remove = ["REGISTER sip:#server_ip# SIP/2.0\r\n",
          "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
          "Max-Forwards: 70\r\n",
          "Contact: <sip:#username#@#client_ip#:#client_port#;transport=UDP>;expires=0\r\n",
          "To: \"#username#\"<sip:#username#@#server_ip#>\r\n",
          "From: \"#username#\"<sip:#username#@#server_ip#>;tag=#tag#\r\n",
          "Call-ID: #call_id_counter#@#server_ip#:5060\r\n",
          "CSeq: #cseq_id# REGISTER\r\n",
          "Allow: #allow#\r\n",
          "User-Agent: VoiPy #user_version#\r\n",
          "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
          "uri=\"sip:#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
          "Content-Length: 0\r\n\r\n"]

ringing_180 = ["SIP/2.0 180 Ringing\r\n",
               "Via: SIP/2.0/UDP #server_ip#:#server_port#;#branch#\r\n",
               "Contact: <sip:#client_ip#:#client_port#;transport=UDP>\r\n",
               "To: #to-raw#;tag=#to-tag#\r\n",
               "From: #from-raw#;tag=#from-tag#\r\n",
               "Call-ID: #call_id_counter#\r\n",
               "CSeq: #cseq_id# #method_reply#\r\n",
               "Allow: #allow#\r\n",
               "User-Agent: VoiPy #user_version#\r\n",
               "Content-Length: 0\r\n\r\n"]

busy = ["SIP/2.0 486 Busy Here\r\n",
        "Via: SIP/2.0/UDP #server_ip#:#server_port#;#branch#\r\n",
        "Contact: <sip:#client_ip#:#client_port#;transport=UDP>\r\n",
        "To: #to-raw#;tag=#to-tag#\r\n",
        "From: #from-raw#;tag=#from-tag#\r\n",
        "Call-ID: #call_id_counter#\r\n",
        "CSeq: #cseq_id# #method_reply#\r\n",
        "Allow: #allow#\r\n",
        "User-Agent: VoiPy #user_version#\r\n",
        "Warning: 399 GS \"Unable to accept call\"\r\n",
        "Content-Length: 0\r\n\r\n"]

terminated_487 = ["SIP/2.0 487 Request Terminated\r\n",
                  "Via: SIP/2.0/UDP #server_ip#:#server_port#;#branch#\r\n",
                  "To: #to-raw#;tag=#to-tag#\r\n",
                  "From: #from-raw#;tag=#from-tag#\r\n",
                  "Call-ID: #call_id_counter#\r\n",
                  "CSeq: 102 INVITE\r\n",
                  "Allow: #allow#\r\n",
                  "User-Agent: VoiPy #user_version#\r\n",
                  "Content-Length: 0\r\n\r\n"]

ignore_480 = ["SIP/2.0 480 \r\n",
              "Via: SIP/2.0/UDP #server_ip#:#server_port#;#branch_invite#;rport=#server_port#\r\n",
              "To: <sip:#username#@#client_ip#:#client_port#;transport=UDP>;tag=#tag#\r\n",
              "From: \"#invite_call#\"<sip:#invite_call#@#server_ip#>;#from_invite#\r\n",
              "Call-ID: #call_id_invite#\r\n",
              "CSeq: #cseq_id_invite# #method_reply#\r\n",
              "User-Agent: VoiPy #user_version#\r\n",
              "Content-Length: 0\r\n\r\n"]

subscribe_remove = ["SUBSCRIBE sip:Unknown@#server_ip#:#server_port# SIP/2.0\r\n",
                    f"Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                    "Max-Forwards: 70\r\n",
                    f"Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
                    f"To: \"#username#\"<sip:#username#@#server_ip#>\r\n",
                    f"From: \"#username#\"<sip:#username#@#server_ip#>;tag=#tag#\r\n",
                    f"Call-ID: #call_id_counter#@#server_ip#:5060\n",
                    f"CSeq: #cseq_id# SUBSCRIBE\r\n",
                    "Expires: 0\r\n",
                    f"User-Agent: VoiPy #user_version#\r\n",
                    f"Allow: #allow#\r\n",
                    f"Event: message-summary\r\n",
                    f"Content-Length: 0\r\n\r\n"]

subscribe_remove_auth = [f"SUBSCRIBE sip:Unknown@#server_ip#:#server_port# SIP/2.0\r\n",
                         f"Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                         f"Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
                         f"To: \"#username#\"<sip:#username#@#server_ip#>\r\n",
                         f"From: \"#username#\"<sip:#username#@#server_ip#>;tag=#tag#\r\n",
                         f"Call-ID: #call_id_counter#@#server_ip#:5060\n",
                         f"CSeq: #cseq_id# SUBSCRIBE\r\n",
                         "Expires: 0\r\n",
                         "User-Agent: VoiPy #user_version#\r\n",
                         "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
                         "uri=\"sip:Unknown@#server_ip#:#server_port#\",response=\"#response#\",algorithm=MD5.\r\n",
                         "Allow: #allow#\r\n",
                         "Event: message-summary\r\n",
                         "Content-Length: 0\r\n\r\n"]

invite = ["INVITE sip:#number#@#server_ip# SIP/2.0\r\n",
          "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
          "Max-Forwards: 70\r\n",
          "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
          "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
          "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag#\r\n",
          "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# INVITE\r\n",
          "Allow: #allow#\r\n",
          "Content-Type: application/sdp\r\n",
          "User-Agent: VoiPy #user_version#\r\n",
          "Content-Length: #content_length#\r\n\r\n",
          "#body#"]

invite_auth = ["INVITE sip:#number#@#server_ip# SIP/2.0\r\n",
               "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
               "Max-Forwards: 70\r\n",
               "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
               "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
               "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag#\r\n",
               "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# INVITE\r\n",
               "Allow: #allow#\r\n",
               "Content-Type: application/sdp\r\n",
               "User-Agent: VoiPy #user_version#\r\n",
               "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
               "uri=\"sip:#number#@#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
               "Content-Length: #content_length#\r\n\r\n",
               "#body#"]

refer_invite = ["INVITE sip:#number#@#server_ip# SIP/2.0\r\n",
                "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                "Max-Forwards: 70\r\n",
                "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
                "To: \"#number#\"<sip:#number#@#server_ip#>;tag=#tag_to#\r\n",
                "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag_from#\r\n",
                "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# INVITE\r\n",
                "Allow: #allow#\r\n",
                "Content-Type: application/sdp\r\n",
                "User-Agent: VoiPy #user_version#\r\n",
                "Content-Length: #content_length#\r\n\r\n",
                "#body#"]

refer_invite_auth = ["INVITE sip:#number#@#server_ip#:#server_port# SIP/2.0\r\n",
                     "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                     "Max-Forwards: 70\r\n",
                     "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
                     "To: \"#number#\"<sip:#number#@#server_ip#>;tag=#tag_to#\r\n",
                     "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag_from#\r\n",
                     "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# INVITE\r\n",
                     "Allow: #allow#\r\n",
                     "Content-Type: application/sdp\r\n",
                     "User-Agent: VoiPy #user_version#\r\n",
                     "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
                     "uri=\"sip:#number#@#server_ip#:#server_port#\",response=\"#response#\",algorithm=MD5.\r\n",
                     "Content-Length: #content_length#\r\n\r\n",
                     "#body#"]

refer = ["REFER sip:#number#@#server_ip# SIP/2.0\r\n",
         "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
         "Max-Forwards: 70\r\n",
         "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
         "To: \"#number#\"<sip:#number#@#server_ip#>;tag=#tag_to#\r\n",
         "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag_from#\r\n",
         "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# REFER\r\n",
         "Allow: #allow#\r\n",
         "User-Agent: VoiPy #user_version#\r\n",
         "Refer-To: <sip:#refer_number#@#server_ip#>\r\n",
         "Referred-By: <sip:#username#@#client_ip#:#client_port#>\r\n",
         "Content-Length: 0\r\n\r\n"]

refer_auth = ["REFER sip:#number#@#server_ip# SIP/2.0\r\n",
              "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
              "Max-Forwards: 70\r\n",
              "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
              "To: \"#number#\"<sip:#number#@#server_ip#>;tag=#tag_to#\r\n",
              "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag_from#\r\n",
              "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# REFER\r\n",
              "Allow: #allow#\r\n",
              "User-Agent: VoiPy #user_version#\r\n",
              "Refer-To: <sip:#refer_number#@#server_ip#>\r\n",
              "Referred-By: <sip:#username#@#client_ip#:#client_port#>\r\n",
              "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
              "uri=\"sip:#number#@#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
              "Content-Length: 0\r\n\r\n"]

answer = ["SIP/2.0 200 OK\r\n",
          "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;\r\n",
          "Max-Forwards: 70\r\n",
          "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
          "To: #to-raw#;tag=#to-tag#\r\n",
          "From: #from-raw#;tag=#from-tag#\r\n",
          "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# #method_replay#\r\n",
          "Allow: #allow#\r\n",
          "Content-Type: application/sdp\r\n",
          "User-Agent: VoiPy #user_version#\r\n",
          "Content-Length: #content_length#\r\n\r\n",
          "#body#"]

message = ["MESSAGE sip:#number#@#server_ip# SIP/2.0\r\n",
           "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
           "Max-Forwards: 70\r\n",
           "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
           "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
           "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag#\r\n",
           "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# MESSAGE\r\n",
           "Allow: #allow#\r\n",
           "Content-Type: text/plain\r\n",
           "User-Agent: VoiPy #user_version#\r\n",
           "Content-Length: #content_length#\r\n\r\n",
           "#body#"]

message_auth = ["MESSAGE sip:#number#@#server_ip# SIP/2.0\r\n",
                "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
                "Max-Forwards: 70\r\n",
                "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
                "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
                "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag#\r\n",
                "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# MESSAGE\r\n",
                "Allow: #allow#\r\n",
                "Content-Type: text/plain\r\n",
                "User-Agent: VoiPy #user_version#\r\n",
                "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
                "uri=\"sip:#number#@#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
                "Content-Length: #content_length#\r\n\r\n",
                "#body#"]

ack_auth = ["ACK sip:#number#@#server_ip# SIP/2.0\r\n",
            "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
            "Max-Forwards: 70\r\nTo: #to-raw#;tag=#to-tag#\r\n",
            "From: #from-raw#;tag=#from-tag#\r\n",
            "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# ACK\r\n",
            "User-Agent: VoiPy #user_version#\r\n",
            "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
            "uri=\"sip:#number#@#server_ip#:#server_port#\",response=\"#response#\",algorithm=MD5.\r\n",
            "Content-Length: 0\r\n\r\n"]

ack = ["ACK sip:#number#@#server_ip# SIP/2.0\r\n",
       "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
       "Max-Forwards: 70\r\nTo: #to-raw#;tag=#to-tag#\r\n",
       "From: #from-raw#;tag=#from-tag#\r\n",
       "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# ACK\r\n",
       "User-Agent: VoiPy #user_version#\r\n",
       "Content-Length: 0\r\n\r\n"]

bye_auth = ["BYE #header# SIP/2.0\r\n",
            "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
            "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
            "Max-Forwards: 70\r\nTo: #to-raw#;tag=#to-tag#\r\n",
            "From: #from-raw#;tag=#from-tag#\r\n",
            "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# BYE\r\n",
            "User-Agent: VoiPy #user_version#\r\n",
            "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
            "uri=\"sip:#number#@#server_ip#:#server_port#\",response=\"#response#\",algorithm=MD5.\r\n",
            "Reason: SIP;description=\"User Hung Up\"\r\n",
            "Content-Length: 0\r\n\r\n"]

bye = ["BYE #header# SIP/2.0\r\n",
       "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
       "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
       "Max-Forwards: 70\r\nTo: #to-raw#;tag=#to-tag#\r\n",
       "From: #from-raw#;tag=#from-tag#\r\n",
       "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# BYE\r\n",
       "User-Agent: VoiPy #user_version#\r\n",
       "Reason: SIP;description=\"User Hung Up\"\r\n",
       "Content-Length: 0\r\n\r\n"]

ok = ["SIP/2.0 200 OK\r\n",
      "Via: SIP/2.0/UDP #server_ip#:#server_port#;branch=#branch#;rport=#server_port#\r\n",
      "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
      "To: #to-raw#;tag=#to-tag#\r\n",
      "From: #from-raw#;tag=#from-tag#\r\n",
      "Call-ID: #call_id_counter#\r\n",
      "CSeq: #cseq_id# #method_replay#\r\n",
      "Accept: application/sdp\r\n",
      "Accept-Language: en\r\n",
      "Allow: #allow#\r\n",
      "User-Agent: VoiPy #user_version#\r\n",
      "Content-Length: 0\r\n\r\n"]

ok_bye = ["SIP/2.0 200 OK\r\n",
          "Via: SIP/2.0/UDP #server_ip#:#server_port#;branch=#branch#;rport=#server_port#\r\n",
          "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
          "To: #to-raw#;tag=#to-tag#\r\n",
          "From: #from-raw#;tag=#from-tag#\r\n",
          "Call-ID: #call_id_counter#\r\n",
          "CSeq: #cseq_id# #method_replay#\r\n",
          "User-Agent: VoiPy #user_version#\r\n",
          "Content-Length: 0\r\n\r\n"]

cancel_auth = ["CANCEL sip:#number#@#server_ip# SIP/2.0\r\n",
            "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
            "Max-Forwards: 70\r\n",
            "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
            "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
            "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#from-tag#\r\n",
            "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# CANCEL\r\n",
            "User-Agent: VoiPy #user_version#\r\n",
            "Authorization: Digest username=\"#username#\",realm=\"asterisk\",nonce=\"#nonce#\","
            "uri=\"sip:#number#@#server_ip#\",response=\"#response#\",algorithm=MD5.\r\n",
            "Content-Length: 0\r\n\r\n"]

cancel = ["CANCEL sip:#number#@#server_ip# SIP/2.0\r\n",
            "Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n",
            "Max-Forwards: 70\r\n",
            "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
            "To: \"#number#\"<sip:#number#@#server_ip#>\r\n",
            "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#from-tag#\r\n",
            "Call-ID: #call_id_counter#\r\nCSeq: #cseq_id# CANCEL\r\n",
            "User-Agent: VoiPy #user_version#\r\n",
            "Content-Length: 0\r\n\r\n"]

options = ["#method# sip:#username#@#server_ip# SIP/2.0\r\n",
           'Via: SIP/2.0/UDP #client_ip#:#client_port#;branch=#branch#;rport\r\n',
           "Max-Forwards: 70\r\n",
           "From: \"#username#\" <sip:#username#@#client_ip#>;tag=#tag#\r\n",
           "To: \"Unknown\"<sip:Unknown@#server_ip#>\r\n",
           "Contact: <sip:#username#@#client_ip#:#client_port#>\r\n",
           "Call-ID: #call_id_counter#@#server_ip#:5060\r\nCSeq: 102 #method#\r\n",
           "User-Agent: VoiPy #user_version#\r\n",
           "Content-Length: 0\r\n\r\n"
           ]
